import { async } from 'rxjs';

const skyid = require('skyid-sdk-web');
const $ = require('jquery');




var API_url = "API_URL"
var OCR_url ="OCR_url"
var LIVENESS_url ="LIVENESS_url"
var FACE_MATCHING_url ="FACE_MATCHING_url"

var skyid_fa_sdk_user = "skyid_fa_sdk_user";
var skyid_fa_sdk_password = "skyid_fa_sdk_password";

const skyid_fa_sdk_token = 'skyid_fa_sdk_token';
const skyid_fa_sdk_appId = 'skyid_fa_sdk_appId';

// skyid face analysis variable
var canvas_selfie=null;
var canvas_document_photo=null;
var skyid_fa_init_error_callback ;
var statuss;
function setVariables(){
    skyid.message_variables.skyid_fa_sdk_access_error_message="Votre token n'est pas valide";
    skyid.message_variables.skyid_fa_sdk_loading_error_message="Error lors de chargement des modules";
    skyid.message_variables.skyid_fa_sdk_network_error_message="Error de connexion au serveur, merci de verifier votre connexion internet";
    skyid.message_variables.skyid_fa_sdk_camera_error_message="Impossible de demmarer votre camera, merci de verifier que votre camera et bien actif";
    skyid.message_variables.skyid_fa_face_start_message="SVP positionner votre visage au centre sans rotation. puis clique sur start.";
    skyid.message_variables.skyid_fa_face_loading_message="Chargement des modules, Patietez SVP.";
    skyid.message_variables.skyid_fa_mul_face_warning_msg="SVP representer un seul visage devant le camera.";
}
setVariables()

  
// In the javascript file  ‘skyid_impl_v1.js’
async function skyid_fa_remote_sdk_initialization()
  {
    var form = new FormData();
    form.append("username", skyid_fa_sdk_user);
    form.append("password", skyid_fa_sdk_password);
  
    $.ajax({
      url : API_url+"login",
        type : "POST",
        data : form,
        cache : false,
        contentType : false,
        processData : false,
        success : function(response) {
            if(response["status_code"]=="000")
            {
                // // You can access the response data  from here
                // const skyid_fa_setup_data=response["response_data"];
  
  
               
                // const temp_token =response["access_token"]; skyid_fa_setup_data["access_token"]
                // skyid_fa_get_params_request(response["access_token"]);

                const skyid_fa_setup_data=response["response_data"];
                 // // You can access the token from here
                const temp_token = skyid_fa_setup_data["access_token"]
                skyid_fa_get_params_request(temp_token);

            }else
            {
                alert(skyid_fa_init_error_callback);
            }
        },
        error: function(xhr, status, error) {
            alert(xhr.status+" : "+xhr.statusText);
        }
      });
}
  

// SDK API init parameters
async function skyid_fa_get_params_request(skyid_fa_auth)
{
       // setup request parameters
       let form_data = new FormData();
       form_data.append("token",skyid_fa_sdk_token);
       form_data.append("application_id",skyid_fa_sdk_appId);
       // send request
       $.ajax({
         url : API_url+"get_parameters_web_sdk",
           type : "POST",
           headers : {"Authorization":"Bearer "+skyid_fa_auth},
           data : form_data,
           cache : false,
           contentType : false,
           processData : false,
           success : function(response) {
                          if(response["status_code"]=="000")
                          {
                              const sdk_data=response["response_data"];
                              skyid.skyid_fa_init_sdk(sdk_data);
                          }else
                          {
                              alert(response["status_label"]);
                          }
           },
           error: function(xhr, status, error) {
               alert(xhr.status+" : "+xhr.statusText);
           }
         });
         // end request

}
  

  function initViewComponent(){
        let skyid_liveness = document.getElementById('skyid_liveness');
        skyid_liveness.innerHTML = skyid.skyid_component;  
  }

  function skyid_fa_stop_webcam(){
    skyid.skyid_fa_stop_webcam() ; 
  }
      
      // Setup face sdk 
  function skyid_fa_setup_sdkMethod(){
        skyid.skyid_fa_setup_sdk()
  }

  

async  function skyid_fa_auth_request_smart_ocr()
{
  const loaddataocrElement = document.getElementById("loaddataocr");
 
  
  const imageInput = document.getElementById("ocrimagge");

    if (!imageInput.files.length) {
        alert("Please select an image.");
        return;
    } 
    


    loaddataocrElement.style.display = "block";
  var form = new FormData();
  form.append("username", skyid_fa_sdk_user);
  form.append("password", skyid_fa_sdk_password);

  $.ajax({
      url : API_url+"login",
      type : "POST",
      crossDomain: true,
      data : form,
      cache : false,
      contentType : false,
      processData : false,
      success : async function( response) {
        loaddataocrElement.style.display = "none";
          if(response["status_code"]=="000")
          {
              const skyid_fa_setup_data=response["response_data"];
              const temp_token = skyid_fa_setup_data["access_token"]
              await   skyid_extract_info_from_doc_request(temp_token)
          }else
          {
            loaddataocrElement.style.display = "none";
              alert("999 - "+response["status_label"]);
          }
      },
      error: function(xhr, status, error) {
        loaddataocrElement.style.display = "none";
          alert("Erreur serveur : "+xhr.status+" : "+xhr.statusText);
      }
    });
}

async function skyid_extract_info_from_doc_request(access_token){
  var form_data = new FormData();
    const imageInput = document.getElementById("ocrimagge");

    const loaddataocrElement = document.getElementById("loaddataocr");
    loaddataocrElement.style.display = "block";


    if (!imageInput.files.length) {
        alert("Please select an image.");
        loaddataocrElement.style.display = "none";
        return;
    } 
  form_data.append("document", imageInput.files[0]);
  form_data.append('institution_id',"institution_id");
  form_data.append('application_id',skyid_fa_sdk_appId);
  form_data.append('channel_id',"channel_id");
  form_data.append('service_id',"service_id");
  form_data.append('sub_service_id',"sub_service_id");
  form_data.append('token',skyid_fa_sdk_token);
  form_data.append("request_data",'{"doc_type":"01"}');
  $.ajax({
      url : OCR_url+"extract_info_from_document",
      type : "POST",
      headers : {"Authorization":"Bearer "+access_token},
      crossDomain: true,
      data : form_data,
      cache : false,
      contentType : false,
      processData : false,
      success : function(fields_data) {
      statuss=fields_data["status_code"]
      if(statuss=="000")
      {
        loaddataocrElement.style.display = "none";
        const resultextractdata = document.getElementById('resultextractdata');
      
        // Format and display the JSON data in the element
        resultextractdata.innerHTML = '<pre>' + JSON.stringify(fields_data.response_data, null, 2) + '</pre>';

        const stepNumber = 2; // The desired step_number value
        const button = document.querySelector(`button[step_number="${stepNumber}"]`);
        
        button.disabled = false; // To disable the button
        button.style.background = '#4361ee'; // Set its background color


      }else{
        loaddataocrElement.style.display = "none";
        alert("document analysis alert, status_code "+statuss+" : "+fields_data["status_label"])
      }

      },
      error: function(xhr, statuss, error) {
        loaddataocrElement.style.display = "none";
        alert("Erreur serveur : "+xhr.status+" : "+xhr.statusText);
      }
    });
}
function process_fa_timeOut() {
  console.log("process_fa_timeOut ");
}
function startskyid_fa_start_face_scan(){
  skyid.skyid_fa_start_face_scan(skyid_fa_face_scan_end_callback, process_fa_timeOut);
}
var my_selfie_canvas = null;

function skyid_fa_face_scan_end_callback(skyid_fa_detected_face_canvas)
{
    my_selfie_canvas=skyid_fa_detected_face_canvas
    skyid_fa_check_liveness(skyid_fa_detected_face_canvas);
}
function skyid_fa_check_liveness(frame_canvas)
{
  const loaddatalivnssElement = document.getElementById("loaddatalvnss");

  var form = new FormData();
  form.append("username", skyid_fa_sdk_user);
  form.append("password", skyid_fa_sdk_password);
  loaddatalivnssElement.style.display = "block";
  $.ajax({
      url : API_url+"login",
      type : "POST",
      data : form,
      cache : false,
      contentType : false,
      processData : false,
      success : function(response) {
          if(response["status_code"]=="000")
          {
              const skyid_fa_setup_data=response["response_data"];
              const temp_token = skyid_fa_setup_data["access_token"]
              skyid_fa_check_liveness_request(temp_token,frame_canvas);
          }else
          {
              alert(response["status_label"]);
          }
      },
      error: function(xhr, status, error) {
          alert(xhr.status+" : "+xhr.statusText);
      }
    });
} 

function skyid_fa_check_liveness_request(skyid_fa_auth,frame_canvas)
{
  const loaddatalivnssElement = document.getElementById("loaddatalvnss");
   //create binary image file
  const canvas_bin = skyid_fa_canvas2binary(frame_canvas);
  const  face_image= new File([canvas_bin], "skyid_fa_selected_frame.jpg",{type:"application/octet-stream"})
  // setup request parameters
  let form_data = new FormData();
  form_data.append("selfie",face_image);
  // send request
  $.ajax({
      url : LIVENESS_url+"check_liveness",
      type : "POST",
      headers : {"Authorization":"Bearer "+skyid_fa_auth},
      data : form_data,
      cache : false,
      contentType : false,
      processData : false,
      success : function(response) {
          loaddatalivnssElement.style.display = "none";
            if(response["status_code"]=="000")
            {
                let api_result=response["response_data"]
                if(api_result["face_class"]=="Real")
                {
                    skyid.skyid_fa_start_face_scan(skyid_fa_face_scan_end_callbackfacematching, process_fa_timeOut);
                   
                    const resultextractdata = document.getElementById('responseOneDisplayrealtimefacedetct');

                    // Format and display the JSON data in the element
                    resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.response_data, null, 2) + '</pre>';


                    
                    const stepNumber = 3; // The desired step_number value
                    const button = document.querySelector(`button[step_number="${stepNumber}"]`);
        
                    setTimeout(function() {
                        // This code will be executed after the delay 1sec
                        button.disabled = false; // Enable the button
                        button.style.background = '#4361ee'; // Set its background color
                      }, 1000);

                

                }else{
                     alert("echec de verification preuve de vue, SVP reessayer dans un environement limunaux");
                }
                $( "#msg" ).html("Result :"+api_result["face_class"]+" score "+api_result["score"]+"<br/><br/>");
            }
            else{
                 alert("echec de verification preuve de vue, SVP reessayer dans un environement limunaux")
            }

          	  $( "#skyid_fa_start_button" ).html("Redemarrer");
              $( "#skyid_fa_start_button" ).show();

      },
      error: function(xhr, status, error) {
        loaddatalivnssElement.style.display = "none";
          alert(xhr.status+" : "+xhr.statusText);
      }
    });
}

function skyid_fa_face_scan_end_callbackfacematching(skyid_fa_detected_face_canvas)
{
    my_selfie_canvas=skyid_fa_detected_face_canvas
    const loaddatafacemtchElement = document.getElementById("loaddatafacemtch");
    loaddatafacemtchElement.style.display = "block";
    const imageInput = document.getElementById("ocrimagge");
    if (!imageInput.files.length) {
        alert("Please select an image.");
        return;
    } 
   
      //Add other form fields as needed
        const canvas_bin = skyid_fa_canvas2binary(my_selfie_canvas);
        const  face_image= new File([canvas_bin], "skyid_fa_selected_frame.jpg",{type:"application/octet-stream"})
        const formDatafacemtch = new FormData();
        // Add other form fields as needed
        formDatafacemtch.append("doc_1_1", imageInput.files[0]);
        formDatafacemtch.append("slf_1", face_image);
        formDatafacemtch.append('guid', 'guid');
        formDatafacemtch.append("token",skyid_fa_sdk_token);
        formDatafacemtch.append("application_id",skyid_fa_sdk_appId);
        $.ajax({
            type: "POST",
            url:  FACE_MATCHING_url+"compare_multi_doc_vs_selfie",
        data: formDatafacemtch,
        processData: false,
        contentType: false,
        success: function (response) {

            loaddatafacemtchElement.style.display = "none";
            if (response.status_code =="000"){
    
                const resultextractdata = document.getElementById('responseOneDisplayrealtimefacedetcttow');
                // Format and display the JSON data in the element
                resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.multi_response_data.doc_1.response_data, null, 2) + '</pre>';
            }else {
                
                const resultextractdata = document.getElementById('responseOneDisplayrealtimefacedetcttow');
    
                // Format and display the JSON data in the element
                resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.status_label, null, 2) + '</pre>';
            }           
        },
        error: function (error) {
            alert("failed.");
        loaddatafacemtchElement.style.display = "none";
        }
    });
}


function skyid_fa_canvas2binary(req_canvas)
{
    let skyid_fa_canvas_data = req_canvas.toDataURL('image/jpeg', 1.0);
    skyid_fa_canvas_data = skyid_fa_canvas_data.replace('data:image/jpeg;base64,', '');
    return skyid_fa_base64ToArrayBuffer(skyid_fa_canvas_data)
}
function skyid_fa_base64ToArrayBuffer(base64) {
	const binary_string =  window.atob(base64);
	const len = binary_string.length;
	var bytes = new Uint8Array( len );
	for (var i = 0; i < len; i++)        {
		bytes[i] = binary_string.charCodeAt(i);
	}
	return bytes.buffer;
}

    
  async function toHelpAwait(){
      await skyid_fa_remote_sdk_initialization()
  }
  toHelpAwait()


//  recover document uniquenqme
function skyid_fa_auth_request_smart_ocr_recover(p_registred_uniquename)
{
  var form = new FormData();
  form.append("username", skyid_fa_sdk_user);
  form.append("password", skyid_fa_sdk_password);

  $.ajax({
      url : API_url+"login",
      type : "POST",
      crossDomain: true,
      data : form,
      cache : false,
      contentType : false,
      processData : false,
      success : function(response) {
          if(response["status_code"]=="000")
          {
              const skyid_fa_setup_data=response["response_data"];
              const temp_token = skyid_fa_setup_data["access_token"]
              skyid_smart_ocr_rocover_request(temp_token,p_registred_uniquename)
          }else
          {
              alert("999 - "+response["status_label"]);
          }
      },
      error: function(xhr, status, error) {
          alert("Erreur serveur : "+xhr.status+" : "+xhr.statusText);
      }
    });
}

function skyid_smart_ocr_rocover_request(access_token,p_document_uniquenqme)
{
  	var form_data = new FormData();
    form_data.append('application_id',skyid_fa_sdk_appId);
    form_data.append('token',skyid_fa_sdk_token);
    form_data.append("document_uniqueName", p_document_uniquenqme);

    $.ajax({
              url : OCR_url+"skyid_ocr_status", 
      		    type : "POST",
                headers : {"Authorization":"Bearer "+access_token},
                crossDomain: true,
                data : form_data,
                cache : false,
                contentType : false,
                processData : false,
      		    success : function(response) {
                //The result is available now    response  
                    console.log(response);
      		    },
                error: function(xhr, status, error) {
                  alert("Erreur serveur : "+xhr.status+" : "+xhr.statusText);
                }
      		});
}



  export{initViewComponent,skyid_fa_setup_sdkMethod , 
    skyid_fa_auth_request_smart_ocr , skyid_fa_stop_webcam, 
    startskyid_fa_start_face_scan , 
    skyid_fa_auth_request_smart_ocr_recover
  }